      PROGRAM DATAGEN
C
C*********************************************************************
C
C     PROGRAM FOR INPUT DATA GENERATION
C
C*********************************************************************
C   
C     1) INPUT FILE    : P.DAT
C     2) OUTPUT FILES  : INFILE
C     3) PROGRAMMED BY : KIM, SEUNG-EOCK
C                        STRUCTURES AREA, SCHOOL OF CIVIL ENGINEERING 
C                        PURDUE UNIVERSITY 
C     4) LAST CHANGED  : JUNE 1996
C     5) VERSION       : 1.0               
C     
C*********************************************************************
C
C--- Dimension and open files
C      
      DIMENSION ICTYPE(10),CMU(10),RKI(10),EXPN(10),
     &   IFTYPE(20),FA(20),FI(20),FZ(20),FE(20),FFY(20),IFCOL(20),
     &   ITTYPE(20),TA(20),TI(20),TE(20),TFY(20),ITCOL(20),
     &   IFMCNT(100),IEND(100),JDCNT(100),
     &   FXO(200),FYO(200),JDFRM(200),IFNODE(200),JFNODE(200),
     &   TXO(200),TYO(200),JDTRS(200),ITNODE(200),JTNODE(200),
     &   IDOF(100,3)
      CHARACTER TITLE*70
      OPEN (UNIT=5, FILE='P.DAT')
      OPEN (UNIT=7, FILE='INFILE')
      OPEN (UNIT=21, FILE='TEMP1')
C
C--- Initialization
C
      ISOLVE=1
      IET=1
      IPHI=1
      NSEQN=1
      IPRTFC=1
      NUMCNTT=1
      NUMFRMT=1
      NUMTRST=1     
C
C--- Read job control data
C
      READ(5,10) TITLE
      READ(5,12) IGEOIM,ILRFD
      READ(5,14) NNODE,NBOUND,NINCRE
      IDOFTL=NNODE*3
      IF (NINCRE.EQ.0) NINCRE=100
   10 FORMAT(A70)
   12 FORMAT(2I5) 
   14 FORMAT(3I5)
C
C--- Read total numbers of element types
C
      READ(5,20) NCTYPE,NFTYPE,NTTYPE
   20 FORMAT(3I5)
C
C--- Read total numbers of elements
C
      READ(5,30) NUMCNT,NUMFRM,NUMTRS
   30 FORMAT(3I5)
C
C--- Read connection property 
C
      IF(NUMCNT.EQ.0) GOTO 50
      DO 40 II=1,NCTYPE
      READ(5,42) ICTYPE(II),CMU(II),RKI(II),EXPN(II)
   40 CONTINUE
   42 FORMAT(I5,3E10.5)
C     
C--- Read frame section property 
C
   50 IF(NUMFRM.EQ.0) GOTO 60
      DO 52 II=1,NFTYPE
      READ(5,54) IFTYPE(II),FA(II),FI(II),FZ(II),FE(II),
     &           FFY(II),IFCOL(II)
   52 CONTINUE     
   54 FORMAT(I5,5E10.5,I5)
C
C--- Readt truss section property 
C
   60 IF(NUMTRS.EQ.0) GOTO 70
      DO 62 II=1,NTTYPE
      READ(5,64) ITTYPE(II),TA(II),TI(II),TE(II),TFY(II),ITCOL(II)
   62 CONTINUE
   64 FORMAT(I5,4E10.5,I5)
C
C--- Read connection element data  
C
   70 IF(NUMCNT.EQ.0) GOTO 80     
   72 READ(5,74) LCNT,IFMCNT(LCNT),IEND(LCNT),JDCNT(LCNT),
     &           NOSMCN,NELINC
      IF(NOSMCN.EQ.0) NOSMCN=1
      IF(NELINC.EQ.0) NELINC=1 
      DO 76 I=1,NOSMCN
        LCNT=LCNT+1
        IFMCNT(LCNT)=IFMCNT(LCNT-1)+NELINC
        IEND(LCNT)=IEND(LCNT-1)
        JDCNT(LCNT)=JDCNT(LCNT-1)
        NUMCNTT=NUMCNTT+1
   76 CONTINUE        
      IF(NUMCNTT.LE.NUMCNT) GOTO 72
   74 FORMAT(6I5)
C
C--- Read frame elememt data 
C
   80 IF(NUMFRM.EQ.0) GOTO 90
   82 READ (5,84) LFRM,FXO(LFRM),FYO(LFRM),JDFRM(LFRM),IFNODE(LFRM),
     &           JFNODE(LFRM),NOSMFE,NODINC       
      IF(NOSMFE.EQ.0) NOSMFE=1
      IF(NODINC.EQ.0) NODINC=1 
      DO 86 I=1,NOSMFE
        LFRM=LFRM+1
        FXO(LFRM)=FXO(LFRM-1)
        FYO(LFRM)=FYO(LFRM-1)
        JDFRM(LFRM)=JDFRM(LFRM-1)
        IFNODE(LFRM)=IFNODE(LFRM-1)+NODINC
        JFNODE(LFRM)=JFNODE(LFRM-1)+NODINC
        NUMFRMT=NUMFRMT+1
   86 CONTINUE        
      IF(NUMFRMT.LE.NUMFRM) GOTO 82
   84 FORMAT(I5,2E10.5,5I5)
C
C--- Read truss element data 
C
   90 IF(NUMTRS.EQ.0) GOTO 100
   92 READ (5,94) LTRS,TXO(LTRS),TYO(LTRS),JDTRS(LTRS),ITNODE(LTRS),
     &            JTNODE(LTRS),NOSMTE,NODINC
      IF(NOSMTE.EQ.0) NOSMTE=1
      IF(NODINC.EQ.0) NODINC=1 
      DO 96 I=1,NOSMTE
         LTRS=LTRS+1
         TXO(LTRS)=TXO(LTRS-1)
         TYO(LTRS)=TYO(LTRS-1)
         JDTRS(LTRS)=JDTRS(LTRS-1)
         ITNODE(LTRS)=ITNODE(LTRS-1)+NODINC
         JTNODE(LTRS)=JTNODE(LTRS-1)+NODINC
         NUMTRST=NUMTRST+1
   96 CONTINUE    
      IF(NUMTRST.LE.NUMTRS) GOTO 92        
   94 FORMAT(I5,2E10.5,5I5)
C
C--- Initialize D.O.F.  
C
  100 DO 102 NODE=1,NNODE
      DO 104 N=1,3
        IDOF(NODE,N)=0
  104 CONTINUE
  102 CONTINUE
C
C--- Read boundary condition
C
      N=0
  110 N=N+1
      READ(5,112) NODE,IDOF(NODE,1),IDOF(NODE,2),IDOF(NODE,3),
     &            NOSMBD,NODINC
      IF(NOSMBD.EQ.0) NOSMBD=1
      IF(NODINC.EQ.0) NODINC=1 
      DO 114 I=1,NOSMBD 
        IF(I.GT.1) N=N+1
        DO 116 II=1,3
          IF(IDOF(NODE,II).EQ.1) IDOFTL=IDOFTL-1
  116   CONTINUE
        IF(NOSMBD.EQ.1) GOTO 118
        IF(NOSMBD.EQ.I) GOTO 118
        NODE=NODE+NODINC
        IDOF(NODE,1)=IDOF(NODE-NODINC,1)
        IDOF(NODE,2)=IDOF(NODE-NODINC,2)
        IDOF(NODE,3)=IDOF(NODE-NODINC,3)
  114 CONTINUE        
  118 IF(N.LT.NBOUND) GOTO 110
  112 FORMAT(6I5)
C
C--- Store NNODE, NBOUND, and IDOF in TEMP1 file used in PAAP.f
C
      WRITE(21,300) NNODE
  300 FORMAT(I5)
      DO 302 NODE=1,NNODE
        WRITE(21,304) NODE,IDOF(NODE,1),IDOF(NODE,2),IDOF(NODE,3)  
  304   FORMAT(4I5)     
  302 CONTINUE      
C
C--- Transfer if D.O.F. is fixed, otherwise increment NEQ
C
      NEQ=0
      DO 120 NODE=1,NNODE
      DO 122 N=1,3
      IF(IDOF(NODE,N).GT.0) GOTO 124
      NEQ=NEQ+1
      IDOF(NODE,N)=NEQ
      GOTO 122
  124 IDOF(NODE,N)=0
  122 CONTINUE
  120 CONTINUE
C
C--- Write job control data            
C
      WRITE(7,130) TITLE
      WRITE(7,132) ISOLVE,IGEOIM,ILRFD
      WRITE(7,134) IET,IPHI
      WRITE(7,136) IDOFTL,NINCRE,NSEQN,IPRTFC
      WRITE(7,132) NCTYPE,NFTYPE,NTTYPE
      WRITE(7,132) NUMCNT,NUMFRM,NUMTRS
  130 FORMAT(A70)
  132 FORMAT(3I5)
  134 FORMAT(2I5)
  136 FORMAT(4I5)  
C
C--- Write connection property
C
      IF(NUMCNT.EQ.0) GOTO 150
      DO 140 II=1,NCTYPE
        WRITE(7,142) ICTYPE(II),CMU(II),RKI(II),EXPN(II)
  140 CONTINUE
  142 FORMAT(I5,3E10.5)
C     
C--- Write frame section property
C
  150 IF(NUMFRM.EQ.0) GOTO 160
      DO 152 II=1,NFTYPE
        WRITE(7,154) IFTYPE(II),FA(II),FI(II),FZ(II),FE(II),
     &               FFY(II),IFCOL(II)
  152 CONTINUE
  154 FORMAT(I5,5E10.5,I5)
C
C--- Write truss section property
C
  160 IF(NUMTRS.EQ.0) GOTO 170
      DO 162 II=1,NTTYPE
        WRITE(7,164) ITTYPE(II),TA(II),TI(II),TE(II),TFY(II),ITCOL(II)
  162 CONTINUE
  164 FORMAT(I5,4E10.5,I5)
C
C--- Write connection element data 
C
  170 IF(NUMCNT.EQ.0) GOTO 180
      DO 172 LCNT=1,NUMCNT
        WRITE(7,174) LCNT,IFMCNT(LCNT),IEND(LCNT),JDCNT(LCNT)
  172 CONTINUE
  174 FORMAT(4I5)

C
C--- Write frame element data 
C
  180 IF(NUMFRM.EQ.0) GOTO 190
      DO 182 LFRM=1,NUMFRM
        IFIDOF=IFNODE(LFRM)
        JFIDOF=JFNODE(LFRM)               
        WRITE (7,184) LFRM,FXO(LFRM),FYO(LFRM),JDFRM(LFRM),
     &           IDOF(IFIDOF,1),IDOF(IFIDOF,2),IDOF(IFIDOF,3),
     &           IDOF(JFIDOF,1),IDOF(JFIDOF,2),IDOF(JFIDOF,3)
  182 CONTINUE
  184 FORMAT(I5,2E10.4,7I5)
C
C--- Write truss element data
C
  190 IF(NUMTRS.EQ.0) GOTO 200
      DO 192 LTRS=1,NUMTRS
        ITIDOF=ITNODE(LTRS)
        JTIDOF=JTNODE(LTRS)               
        WRITE (7,194) LTRS,TXO(LTRS),TYO(LTRS),JDTRS(LTRS),
     &                IDOF(ITIDOF,1),IDOF(ITIDOF,2),
     &                IDOF(JTIDOF,1),IDOF(JTIDOF,2)   
  192 CONTINUE
  194 FORMAT(I5,2E10.4,5I5)
C
C--- Read and write loads data
C
  200 READ(5,202,END=999) NODE,XLOAD,YLOAD,RLOAD,NOSMLD,NODINC
      IF(NOSMLD.EQ.0) NOSMLD=1
      IF(NODINC.EQ.0) NODINC=1   
      DO 204 I=1,NOSMLD      
        IF(XLOAD.NE.0.0) THEN 
          N=1
          FLOAD=XLOAD
          GOTO 206
        ENDIF
  212   IF(YLOAD.NE.0.0) THEN 
          N=2
          FLOAD=YLOAD
          GOTO 206
        ENDIF
  214   IF(RLOAD.NE.0.0) THEN
            N=3
            FLOAD=RLOAD
            GOTO 206 
          ELSE
            GOTO 208
        ENDIF
  206   WRITE(7,210) IDOF(NODE,N),FLOAD
        IF(N.EQ.1) GOTO 212 
        IF(N.EQ.2) GOTO 214
        N=0 
  208   NODE=NODE+NODINC
  204 CONTINUE
      GOTO 200 
  202 FORMAT(I5,3E10.4,2I5)
  210 FORMAT(I5,E10.4)
  999 END    

